;***********************************************************
   Name 	CPTime
   Title	   
   Subtitle	  
   Page 	66,132
;*  = CPTime = check perfomance time
;*
;* :       Adamanteus
;*      MASM ver 6.1        27.05.2007
;* : 
;*	    
;*	    
;* :
;*	    
;*	    (TOC)
;*	    
;***********************************************************

		ifnDef modl
modl	TEXTEQU <flat>
lang	TEXTEQU <c>
vend	TEXTEQU <os_dos>
		EndIf

	include masm32rt.inc
	.586

IFDEF MASM32_INC
__WIN32__	EQU	1
COUNTRY	EQU	1
lf	equ	0AH	; ^J
cr	equ	0DH	; ^M
eos	equ	00H	; ^@  
preserve	TEXTEQU	<edi esi>	;   /
POINTER	TEXTEQU	<PTR>	;    
PRINT	macro	STRING
 if TYPE (STRING) LT 4
    INVOKE puts, ADDR STRING
 else
    INVOKE puts, STRING
 endif
ENDM
ELSE
	.MODEL	modl, lang, vend
	option casemap:none

	option language:stdcall

ifDef WIN32
	include	windows.inc
	include	kernel32.inc
	include	user32.inc
	include	gdi32.inc
	includelib	kernel32.lib
	includelib	user32.lib
	includelib	gdi32.lib
Endif

ifDef	WIN
 ifnDef __WIN32__
	include	win.inc
 Endif
Endif
	option language:lang

	include lexam.mac   	;  
ENDIF

;:::::::  ::::::::::::::::::::::::::::::::::::::::::::::::::

ifDef __WIN32__
PFS	EQU	0	;   
else
 ifdef PB
PFS	EQU	0	;   
 else
PFS	EQU	'$'
 endif
endif

REPEAT_BLOCK	EQU	100	;    
TimerFreq	EQU	1193	;      
CORRELATION	EQU	13	;     

;:::::::   :::::::::::::::::::::::::::::::::::::::::::::

ifDef	WIN
 ifnDef __WIN32__
 EXTERN	PASCAL InitTask : FAR, PASCAL InitApp : FAR, PASCAL WaitEvent : FAR
 EndIf
 PUBLIC	Initialize	;   
; WndProc		PROTO FAR PASCAL,  :HWND, :WORD, :SWORD, :SDWORD
Endif

priority	TEXTEQU <REALTIME_PRIORITY_CLASS>
		; HIGH_PRIORITY_CLASS
		; REALTIME_PRIORITY_CLASS

Start	TEXTEQU <Initialize>

IFNDEF MASM32_INC
timer_freq	PROTO : POINTER
num2str	PROTO	num : DWORD , base : BYTE, sign : BYTE, pstr : POINTER
ENDIF

;:::::::  ::::::::::::::::::::::::::::::::::::::::::::::::::::

.DATA

ifDef WIN
 ifnDef __WIN32__
;	PUBLIC	reserved,oldRegSP,oldRegSS,pLocalHeap,pAtomTable,
;		pStackTop,pStackMin,pStackBot
reserved	DW	36	;   
oldRegSP	DW 0
oldRegSS	DW 5
pLocalHeap	DW 0
pAtomTable	DW 0
pStackTop	DW 0
pStackMin	DW 0
pStackBot	DW 0
DT	0	; - 
 Endif
Else
 ifdef __WIN32__
hStdOut	DD  0
 endif
Endif

ALIGN	8
start_time	DQ	?
finish_time	DQ	?
numw	DW	?
num	DD	?
buffer	DB 12 DUP(?)

.CONST
ifDef	WIN
banner	DB	" ",0
text	DB	"  !",0
Else
if COUNTRY eq 7
 ifDef __WIN32__
banner	DB	"⮢ ணࠬ",0
 Endif
 ifdef TOC
cmdtext	DB	"५  ",PFS
fintext	DB	" ⨪ ⠩",cr,lf,PFS
 else
cmdtext	DB	"100 DIV EBX : ",PFS
dottext	DB	"  ",PFS
fintext	DB	" ",cr,lf,PFS
 endif
else
 ifDef __WIN32__
banner	DB	"Test program",0
 Endif
 ifdef TOC
cmdtext	DB	"Correlation on ",PFS
fintext	DB	"timer ticks",cr,lf,PFS
 else
cmdtext	DB	"Command - 100 repeat DIV EBX : ",PFS
dottext	DB	" ms ",PFS
fintext	DB	" ns",cr,lf,PFS
 endif
endif
Endif

.STACK

.CODE

ALIGN	16

ifDef	WIN
Initialize:
 ifnDef __WIN32__   ; 16- 
;	   DS
	XOR	BP,BP
	PUSH	BP
	CALL InitTask	;  
	OR AX,AX    ;  ?
	JZ noinit	; - 
	ADD	CX,256	;  
	JC noinit	;  

;	    

	PUSH	DI	; hInstance
	XOR	AX,AX	;  
	PUSH	AX	; - NULL

;	    

if @DataSize
	MOV	AX,0FFFFh
	PUSH	AX
	CALL LockSegment
endif

;	  

	CALL WaitEvent	;     
	CALL InitApp	;  
	OR AX,AX	;  ?
	JZ noinit	; - 

;	    

	JMP WinMain

noinit:
;	 
	MOV	AL,-1
	CallOS term_proc
 EndIf
WinMain:
	;     

	INVOKE MessageBox, NULL, ADDR text, ADDR banner, MB_OK or MB_ICONASTERISK

	;  
	; ...

	;   
 ifDef __WIN32__
	INVOKE ExitProcess, NULL
 Else
	MOV	AL,0
	CallOS term_proc
 EndIf

Else

puts	PROC USES preserve,
	pstr : POINTER
 ifdef __WIN32__
	MOV	   EDI, pstr
	MOV    ECX, -1
	MOV    AL, eos
	CLD
	REPNE SCASB
	NEG    ECX
	DEC    ECX
	DEC    ECX
	INVOKE WriteConsole, hStdOut, pstr, ECX, NULL, NULL
 else
	pushDS_
	LDS_	SI,pstr
PUTING:
	LODRB	DL,SI
	OR	DL,DL
	JZ	EXIT
	PUSH	SI
	CallOS disp_out
	POP	SI
	INC	SI
	JMP PUTING
EXIT:
	popDS_
 endif
	RET
puts    ENDP

Initialize:
 ifdef __WIN32__
	INVOKE SetConsoleTitle, ADDR banner
	INVOKE GetStdHandle, STD_OUTPUT_HANDLE
	MOV hStdOut,EAX
 else
	INIT_DS
	MOV	ES, AX	;     
	MOV	SS, AX	;    
 endif

	PRINT cmdtext

	;   
 ifdef __WIN32__
	IFNB <priority>
		INVOKE GetCurrentProcess
		INVOKE SetPriorityClass, eax, priority
    ENDIF

	XOR EAX, EAX	;   CPUID
	CPUID
	XOR EAX, EAX
	CPUID
	XOR EAX, EAX
	CPUID

 endif

	;   
 ifdef __WIN32__
	INVOKE QueryPerformanceCounter, ADDR start_time
 else
	;  
	MOV	WORD PTR start_time + 6, 0
	MOV	WORD PTR finish_time + 6, 0
	INVOKE timer_freq, ADDR start_time
 endif

	;  
	MOV	EAX, 10
	MOV	EDX, 0
	MOV	EBX, 100

	;   
 ifndef TOC
	REPT REPEAT_BLOCK
	REPT 100
		DIV EBX
	ENDM
	ENDM
 endif

	;   
 ifdef __WIN32__
	INVOKE QueryPerformanceCounter, ADDR finish_time
 else
	INVOKE timer_freq, ADDR finish_time
 endif

	;     
	FILD finish_time
	FILD start_time
	FSUB

 ifdef TOC
 	;   
	FISTP num	;   
IFDEF MASM32_INC
	INVOKE	dwtoa, num, ADDR buffer
ELSE
	INVOKE num2str, num, 10, 0, ADDR buffer
ENDIF
	PRINT buffer
	PRINT fintext
 else
	;     
	MOV	numw, CORRELATION
	FISUB numw	;   -   
	MOV	numw, REPEAT_BLOCK
	FIDIV numw	;      
	FLD ST
 ifdef __WIN32__
	INVOKE QueryPerformanceFrequency, ADDR start_time
	MOV	EAX, DWORD PTR start_time
	MOV	EDX, DWORD PTR start_time + 4
	MOV	EBX, 10000
	DIV	EBX
	MOV	numw, AX
 else
	MOV	numw, TimerFreq
 endif
	FIDIV numw
	FISTP num	;  
	.IF num != 0
IFDEF MASM32_INC
		INVOKE	dwtoa, num, ADDR buffer
ELSE
		INVOKE num2str, num, 10, 0, ADDR buffer
ENDIF
		PRINT buffer
		PRINT dottext
	.ENDIF
	FILD num
	FIMUL numw	;     
	FSUB
	MOV	num, 1000
	FIMUL num
	FIDIV numw
	FISTP num	;  
IFDEF MASM32_INC
	INVOKE	dwtoa, num, ADDR buffer
ELSE
	INVOKE num2str, num, 10, 0, ADDR buffer
ENDIF
	PRINT buffer
	PRINT fintext
 endif

 ifdef __WIN32__
	INVOKE GetCurrentProcess
	INVOKE SetPriorityClass, eax, NORMAL_PRIORITY_CLASS
	INVOKE ExitProcess, NULL
 else
	CallOS term_proc
 endif
Endif

END Start	;  
	